package Logic;
import Entity.Device;
import Entity.Node;
import java.util.LinkedList;
public class CorrectDevices {
    //交点坐标
    private LinkedList<Node> nodes;
    //一辆车被拍摄到的设备ID
    LinkedList<Device> devices;
    public CorrectDevices(LinkedList<Node> nodes,  LinkedList<Device> devices) {
        this.nodes = nodes;
        this.devices = devices;
    }

    /**
     * 纠正全部设备点的坐标
     * @return 返回纠正过的设备链表
     */
    //纠正全部设备点的坐标
    public LinkedList<Device> AllCorrectDevice(){
        for(int i = 0;i<devices.size();i++){
            Device device = devices.get(i);
            device = CorrectDeviceLocation(device);
            devices.set(i,device);
        }

        return devices;
    }

    /**
     * 纠正一个设备的坐标以及设置该设备对应路网的点的ID
     * @param device 设备对象
     * @return 纠正完的的设备对象
     */
    public Device CorrectDeviceLocation(Device device){
        String id = device.getDeviceID();
        double x1 = device.getLon();
        double y1 = device.getLat();
        double Mindis = 99999999;
        int temp = 0;
        //找到距离最近的一个交点为该设备在路网上的交点
        for(int i = 0;i<nodes.size();i++){
            double x2 = nodes.get(i).getLon();
            double y2 = nodes.get(i).getLat();
            double dis =  Math.pow(x1-x2,2)+Math.pow(y1-y2,2);
            if(dis < Mindis){
                temp = i;
                Mindis = dis;
            }
        }
        //设置设备的属性
        device.setLon(nodes.get(temp).getLon());
        device.setLat(nodes.get(temp).getLat());
        device.setDeviceID(id);
        device.setNodeID(nodes.get(temp).getNodeID());
        return device;
    }
}
