package Logic;

import Entity.Node;

import java.io.*;
import java.util.LinkedList;

public class FileOperation {
    //车牌号
    String carName;
    //车的路径
    LinkedList<Node> nodes;

    public FileOperation() {
    }

    public FileOperation(String carName, LinkedList<Node> nodes) {
        this.carName = carName;
        this.nodes = nodes;
    }


    /**
     * 指定文件路径，将车辆经过点按照一定格式写入txt文件
     * @param filePath  存储车辆路径的文件路径
     */
    public void WritePath(String filePath){
        int i;
        File fileName = new File(filePath);
        try {
            fileName.createNewFile();
            FileWriter writer = new FileWriter(fileName);
            BufferedWriter out = new BufferedWriter(writer);
            //文件存储格式为
            //起点ID-终点ID 起点经度 起点纬度 终点经度 终点纬度
            for(i = 0;i<nodes.size()-1;i++){
                String line = nodes.get(i).getNodeID()+"-"+nodes.get(i+1).getNodeID()+" "+nodes.get(i).getLon()+" "+nodes.get(i).getLat()+" "+nodes.get(i+1).getLon()+" "+nodes.get(i+1).getLat();
                out.write(line+"\n");
            }
            out.flush();
        }catch (Exception e){
            System.out.println(e.getMessage());
        }
    }


    /**
     * 读取指定文件路径的车辆路径信息
     * @param filepath  需要读取文件的路径
     * @return  经过的点
     */
    public LinkedList<Node> ReadPath(String filepath){
        LinkedList<Node> nodes  = new LinkedList<>();
        try {
            FileReader fileReader = new FileReader(filepath);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            String line;
            int n = 0;
            //解析车路径的信息，包括经过路网的点ID以及点的经纬度
            while ((line = bufferedReader.readLine()) != null){
                String [] data = line.split(" ");
                String [] nodeID = data[0].split("-");
                if(n == 0){
                    Node node1 = new Node(Integer.valueOf(nodeID[0]),Double.valueOf(data[1]),Double.valueOf(data[2]));
                    Node node2 = new Node(Integer.valueOf(nodeID[1]),Double.valueOf(data[3]),Double.valueOf(data[4]));
                    nodes.add(node1);
                    nodes.add(node2);
                }else {
                    Node node = new Node(Integer.valueOf(nodeID[1]),Double.valueOf(data[3]),Double.valueOf(data[4]));
                    nodes.add(node);
                }
                n++;
            }
        }catch (Exception e){
            System.out.println(e.getMessage());
        }
        return nodes;
    }


}
