package Logic;

import Entity.ArcNode;
import Entity.Graph;
import Entity.Node;
import Entity.VertexNode;
import Mapper.RoadMapper;
import Utils.GraphUtil;
import org.apache.ibatis.session.SqlSession;

import java.util.ArrayList;
import java.util.LinkedList;

public class FinalPath {
    private Graph graph;

    public Graph getGraph() {
        return graph;
    }

    public void setGraph(Graph graph) {
        this.graph = graph;
    }

    /**
     * 经过最短路径进一步处理，得到最终车的路径
     * @param temp_path 一辆车经过的路网上的点
     * @param big_graph 通过路网关系建立的图
     * @return  车的最终经过的点
     */
    public LinkedList<Node> getFinalPath(LinkedList<Node> temp_path, Graph big_graph){
        //跟据第一次得到的路径建立图
        graph = GraphUtil.PathGraph(temp_path,big_graph);
        Dijkstra dijkstra = new Dijkstra(graph);
        LinkedList<Node> path = new LinkedList<>();
        //通过处理得到该车的最终路径
        if(dijkstra.getShortPath(temp_path.get(0).getNodeID(),temp_path.get(temp_path.size()-1).getNodeID())){
            path = dijkstra.getRoadPath();
        }
        return path;
    }
}
