package Logic;

import Entity.Node;
import Logic.CarPath;
import Logic.FileOperation;
import Mapper.RoadMapper;
import Utils.MyBatisUtil;
import org.apache.ibatis.session.SqlSession;

import java.io.File;
import java.util.LinkedList;

public class MoreCarPath {
    //查找到轨迹的车的数量
    private int sum;
    //没有找到轨迹的车的数量
    private int error;
    //查找到轨迹的车的车牌号
    private LinkedList<String> carIDs;

    public LinkedList<String> getCarIDs() {
        return carIDs;
    }

    public void setCarIDs(LinkedList<String> carIDs) {
        this.carIDs = carIDs;
    }

    public int getSum() {
        return sum;
    }

    public void setSum(int sum) {
        this.sum = sum;
    }

    public int getError() {
        return error;
    }

    public void setError(int error) {
        this.error = error;
    }

    /**
     * 按照卡口编号和时间进行轨迹查询
     * @param start_hour    起始时间的小时
     * @param start_minute  起始时间的分钟
     * @param end_hour  结束时间的小时
     * @param end_minute    结束时间的分钟
     * @param deviceID  指定的卡口编号
     */
    public void getCarPath(String start_hour, String start_minute, String end_hour, String end_minute, String deviceID){
        /**
         * 创建限制条件的文件夹
         * 文件夹命名格式   eg：7点1分--7点1分(330200000100020070)
         */
        String filename = start_hour+"点"+start_minute+"分"+"--"+end_hour+"点"+end_minute+"分"+"("+deviceID+")";
        File file = new File("D:\\workspace\\FindCarPath\\CarPath\\"+filename);
        //如果文件夹不存在，创建
        if(!file.exists()){
            file.mkdir();
        }
        String start = ChangeTime(start_hour,start_minute);
        String end = ChangeTime(end_hour,end_minute);
        SqlSession sqlSession = MyBatisUtil.getSqlSessionFactory().openSession();
        RoadMapper roadMapper = sqlSession.getMapper(RoadMapper.class);
        carIDs = roadMapper.getMoreCarID(start,end,deviceID);
        sum = carIDs.size();    //该时间段的车辆数量
        error = 0;
        int count = 1;
        for(String carID:carIDs){
            System.out.println("已开始处理第"+count+"辆车");
            CarPath carPath =  new CarPath(carID);
            if(carPath.getPath()){
                LinkedList<Node> path = carPath.getCarPath();
                FileOperation fileOperation = new FileOperation(carID,path);
                fileOperation.WritePath("D:\\workspace\\FindCarPath\\CarPath\\"+filename+"\\"+carID+".txt");
                System.out.println("第"+count+"辆车成功找到路径");
            }else {
                System.out.println("第"+count+"辆车没有找到路径");
                error++;
            }
            count++;
        }
        System.out.println(sum+"辆车处理完毕，"+ (sum-error)+"辆车成功找到路径,"+error+"辆车没有找到路径!");
    }
    /**
     * 修改日期格式与数据库格式一样
     * @param hour  时间的小时
     * @param minute    时间的分钟
     * @return
     */
    public  String ChangeTime(String hour,String minute){
        String time;
        String new_hour;
        String new_minute;
        if(Integer.valueOf(hour)<10){
            new_hour = "0"+hour;
        }else {
            new_hour = hour;
        }
        if(Integer.valueOf(minute)<10){
            new_minute = "0"+minute;
        }else {
            new_minute = minute;
        }
        time = "2018-06-01 "+new_hour+":"+new_minute+":"+"00.0000000";
        return time;
    }
}
