package Mapper;

import Entity.Device;
import Entity.Node;
import Entity.RoadNode;
import Entity.VertexNode;
import org.apache.ibatis.annotations.Param;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public interface RoadMapper {
    /**
     * 通过数据库查询得到路网上点与点之间的关系
     * @return  一条路
     */
    LinkedList<RoadNode> getRoadNodes();
    /**
     * 通过数据库查询所有的点
     * @return  路网上点的集合
     */
    ArrayList<VertexNode> getVertexNodes();

    /**
     * 通过数据库查询一辆车经过的卡口设备
     * @param CarID 查询车辆轨迹的车牌号
     * @return  设备的集合
     */
    LinkedList<Device> getDevice(String CarID);

    /**
     * 通过数据库查询得到所有交点
     * @return  所有交点的集合
     */
    LinkedList<Node> getNodes();

    /**
     * 通过数据库查询指定时间段和卡口设备的车辆
     * @param start
     * @param end
     * @param deviceID
     * @return  这个时间段和卡口经过车辆的车牌号
     */
    LinkedList<String> getMoreCarID(@Param("start")String start,@Param("end") String end,@Param("deviceID") String deviceID);
}
