package ServletControl;

import Entity.Graph;
import Entity.Node;
import Logic.CarPath;
import Logic.FileOperation;
import Logic.FinalPath;
import net.sf.json.JSONArray;

import javax.servlet.annotation.WebServlet;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;

@WebServlet("/CarPathServlet")
public class CarPathServlet extends javax.servlet.http.HttpServlet {
    protected void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, IOException {
        doGet(request,response);
    }

    /**
     * 通过拿到前端传输的车牌号，找到这辆车的路径，并将路径存储到本地3
     * 并将结果返回给前端
     */
    protected void doGet(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, IOException {
        request.setCharacterEncoding("utf-8");
        response.setContentType("text/html;charset=utf-8");
        PrintWriter out = response.getWriter();
        String PlateNum = request.getParameter("plateNum");
        CarPath carPath =  new CarPath( PlateNum);
        LinkedList<Node> path;
        //判断是否找到了路径
        if(carPath.getPath()){
            path = carPath.getCarPath();
            FileOperation fileOperation = new FileOperation(PlateNum,path);
            fileOperation.WritePath("D:\\workspace\\FindCarPath\\CarPath\\"+PlateNum+".txt");
            String jsonnNodes = JSONArray.fromObject(path).toString();
            out.write(jsonnNodes);
        }
        //该车没有找到的路径的情况
        else {
           out.write ("结果:"+PlateNum+"没有轨迹");
        }

    }
}
