package ServletControl;

import Logic.MoreCarPath;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;

@WebServlet("/MoreCarPathServlet")
public class MoreCarPathServlet extends HttpServlet {
    /**
     * 通过前端传输的时间段以及卡口设备编号进行查询这个条件下的车辆的路径，将其每辆车的路径存储在本地
     * 将查询到的统计结果以及这个限制条件下经过的车的车牌号传送给前端
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        request.setCharacterEncoding("utf-8");
        response.setContentType("text/html;charset=utf-8");
        PrintWriter out = response.getWriter();
        //获取到前端传回来的属性
        String start_hour = request.getParameter("start_hour");
        String start_minute = request.getParameter("start_minute");
        String end_hour = request.getParameter("end_hour");
        String end_minute = request.getParameter("end_minute");
        String deviceID = request.getParameter("deviceID");
        MoreCarPath moreCarPath = new MoreCarPath();
        moreCarPath.getCarPath(start_hour,start_minute,end_hour,end_minute,deviceID);
        //设置向前端传送的字符串，首先是文字说明，然后是该限制条件下出现的车牌号，以'&'号分隔
        String text = start_hour+"点"+start_minute+"分"+"到"+end_hour+"点"+end_minute+"分"+"被"+deviceID+"拍摄到"+moreCarPath.getSum()+"辆车，"+"其中错误的车有"+moreCarPath.getError()+"辆。";
        LinkedList<String> carIDs = moreCarPath.getCarIDs();
        out.write(text+"&");
        for(String i:carIDs){
            out.write(i+"&");
        }
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        doPost(request,response);
    }
}
