package ServletControl;

import Entity.Node;
import Logic.FileOperation;
import net.sf.json.JSONArray;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;

@WebServlet("/SingleCarPathServlet")
public class SingleCarPathServlet extends HttpServlet {
    /**
     * 在已经查询到指定条件下的车牌号后，通过车牌号去本地查询车辆的路径
     * 将路径返回给前端
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        request.setCharacterEncoding("utf-8");
        response.setContentType("text/html;charset=utf-8");
        PrintWriter out = response.getWriter();
        //获取到前端传回来的属性
        String carID = request.getParameter("carID");
        String start_hour = request.getParameter("start_hour");
        String start_minute = request.getParameter("start_minute");
        String end_hour = request.getParameter("end_hour");
        String end_minute = request.getParameter("end_minute");
        String deviceID = request.getParameter("deviceID");
        //设置存储车路径的文件路径
        String filePath = "D:\\workspace\\FindCarPath\\CarPath\\"+start_hour+"点"+start_minute+"分"+"--"+end_hour+"点"+end_minute+"分"+"("+deviceID+")\\"+carID+".txt";
        FileOperation fileOperation = new FileOperation();
        LinkedList<Node> path = fileOperation.ReadPath(filePath);
        //将对象数组转换为json格式的字符串
        String jsonnNodes = JSONArray.fromObject(path).toString();
        //向前端传送数据
        out.write(jsonnNodes);
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        doPost(request,response);
    }
}
