package Utils;

import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;

public class MyBatisUtil {

    private static SqlSessionFactory sqlSessionFactory = null;

    /**
     * 读取连接数据库的配置文件
     * @return  连接该数据库的SqlSessionFactory对象
     */
    public static SqlSessionFactory getSqlSessionFactory(){
        if(sqlSessionFactory == null){
            try{
                String resource = "data/mybatis_config.xml";
                sqlSessionFactory = new SqlSessionFactoryBuilder().build(Resources.getResourceAsStream(resource));
                return sqlSessionFactory;
            }catch (Exception e){
                System.err.println(e.getMessage());
            }

        }
        return sqlSessionFactory;
    }
}
